package de.laliluna.howto.application;

import com.sun.faces.context.FacesContextImpl;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContextWrapper;
import javax.faces.context.FacesContext;
import javax.faces.lifecycle.Lifecycle;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 23.10.2009
 */
public class CustomFacesContext extends FacesContextWrapper{
	private String wizardId;

	private static ThreadLocal<CustomFacesContext> contextThreadLocal = new ThreadLocal<CustomFacesContext>();

	private FacesContext wrapped;

	public CustomFacesContext(FacesContext wrapped) {
		this.wrapped = wrapped;
		contextThreadLocal.set(this);
	}

	public static CustomFacesContext getCurrentInstance(){
		return contextThreadLocal.get();
	}

	@Override
	public void release() {
		this.wizardId = null;
		contextThreadLocal.set(null);
		contextThreadLocal.remove();
		super.release();
	}

	public boolean isWizardEnabled(){
		return wizardId != null;
	}

	public String getWizardId() {
		return wizardId;
	}

	public void setWizardId(String wizardId) {
		this.wizardId = wizardId;
	}

	public FacesContext getWrapped() {
		return wrapped;
	}
}
