package de.laliluna.howto.application;

import de.laliluna.howto.beans.UserBean;

import javax.el.ExpressionFactory;
import javax.el.ValueExpression;
import javax.faces.application.Application;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 21.10.2009
 */

public class LocaleRenderPhaseListener implements PhaseListener{
	public void afterPhase(PhaseEvent phaseEvent) {
	}

	public void beforePhase(PhaseEvent phaseEvent) {
		FacesContext context = phaseEvent.getFacesContext();
				// We only want to play with this on the localization2 page
		if(!context.getExternalContext().getRequestPathInfo().contains("localization2"))
				return;
		// Get the managed bean #{userBean}
		Application application = context.getApplication();
		ExpressionFactory factory = application.getExpressionFactory();
		ValueExpression valueExpression = factory.createValueExpression(context.getELContext(),
				"#{userBean}", UserBean.class);
		UserBean userBean = (UserBean) valueExpression.getValue(context.getELContext());

		context.getViewRoot().setLocale(userBean.getLocale());
	}

	public PhaseId getPhaseId() {
		return PhaseId.RENDER_RESPONSE;
	}
}
