package de.laliluna.howto.beans;

import de.laliluna.howto.model.Article;
import de.laliluna.howto.services.ServiceFactoryImp;
import de.laliluna.howto.services.ArticleService;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import java.util.Date;
import java.util.List;
import java.util.Arrays;
import java.util.ArrayList;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 15.10.2009
 */
@ManagedBean
@SessionScoped
public class AjaxBean {

	private int counter;

	private String word;

	private List<String> words = Arrays.asList("anton", "anna", "alfons", "berta", "bambi", "bernd", "carla", "charles");

	public void increase() {
		counter++;
	}

	public int getCounter() {
		return counter;
	}

	public String getTime() {
		return new Date().toString();
	}

	public List<String> getWords() {
		if (word == null)
			return words;
		else {
			List<String> filtered = new ArrayList<String>();
			String lower = word.toLowerCase();
			for (String w : words) {
				if (w.startsWith(lower))
					filtered.add(w);
			}
			return filtered;
		}

	}

	public String getWord() {
		return word;
	}

	public void setWord(String word) {
		this.word = word;
	}

}
