package de.laliluna.howto.beans;

import de.laliluna.howto.services.MessageFactory;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import java.util.Date;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 20.10.2009
 */
@ManagedBean
public class InputBeanCross {
	private Date from;
	// binding for the from input to access the value before it is written to the from field

	private UIInput fromInput;

	private Date to;

	public void validateMe(FacesContext context,
												 UIComponent component,
												 Object value) throws ValidatorException {
		if (value == null)
			return;
		Date fromDate = (Date) fromInput.getValue();
		Date toDate = (Date) value;

		if (fromDate == null) {
			FacesMessage message = MessageFactory.getMessage(context, "validation_from_null");
			// add the error message to the from field
			context.addMessage(fromInput.getClientId(context), message);
			fromInput.setValid(false);
			// add the error message to the to field
			throw new ValidatorException(message);
		}
		if (toDate.before(fromDate)){
			FacesMessage message = MessageFactory.getMessage(context, "validation_from_to");
			// add the error message to the from field
			context.addMessage(fromInput.getClientId(context), message);
			fromInput.setValid(false);
			// add the error message to the to field
			throw new ValidatorException(message);
		}
	}

	public String save() {
		return null;
	}

	public Date getFrom() {
		return from;
	}

	public void setFrom(Date from) {
		this.from = from;
	}

	public Date getTo() {
		return to;
	}

	public void setTo(Date to) {
		this.to = to;
	}

	public UIInput getFromInput() {
		return fromInput;
	}

	public void setFromInput(UIInput fromInput) {
		this.fromInput = fromInput;
	}

}
