package de.laliluna.howto.beans;

import de.laliluna.howto.model.Article;
import de.laliluna.howto.services.ServiceFactoryImp;
import de.laliluna.howto.services.ArticleService;

import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 22.10.2009
 */
@ManagedBean
public class InputBeanRedirect {

	private Integer id;
	private Article article;

	public InputBeanRedirect() {
		this.article = new Article();
	}

	public void load(){
		ArticleService service = ServiceFactoryImp.getInstance().getService(ArticleService.class);
		article = service.findById(article.getId());
	}

	public String save(){
		FacesContext context = FacesContext.getCurrentInstance();
		context.getExternalContext().getFlash().setKeepMessages(true);
		context.addMessage(null, new FacesMessage("The name was successfully saved "));
		context.getExternalContext().getFlash().put("foo","bar");
		return "inputredirect?faces-redirect=true&includeViewParams=true";
	}

	public Article getArticle() {
		return article;
	}

	public void setArticle(Article article) {
		this.article = article;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}
