package de.laliluna.howto.components;

import javax.faces.component.html.HtmlOutputLabel;
import javax.faces.component.UIComponentBase;
import javax.faces.component.FacesComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.event.FacesEvent;
import javax.faces.event.ActionEvent;
import java.io.IOException;
import java.util.logging.Logger;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 25.09.2009
 */
@FacesComponent("de.laliluna.howto.components.Foo")
public class Foo extends UIComponentBase {
	Logger logger = Logger.getLogger("Foo");
	public String getFamily() {
		return "bla";
	}

	public void decode(FacesContext context) {
		super.decode(context);
		getAttributes().put("styleClass", "execute");
	}

	public void encodeBegin(FacesContext context) throws IOException {
		String style = (String) getAttributes().get("styleClass");
		if (style == null) {
			getAttributes().put("styleClass", "initial-render");
		}
		ResponseWriter writer = context.getResponseWriter();
		writer.startElement("h2",null);
		writer.write("foo");
		writer.endElement("h2");
	}

	

	@Override
	public void setRendered(boolean rendered) {
		logger.info("Rendered is set");
		super.setRendered(rendered);
	}
}
