package de.laliluna.howto.components;

import javax.faces.component.UIComponentBase;
import javax.faces.component.FacesComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.el.ValueExpression;
import java.io.IOException;
import java.util.logging.Logger;

@FacesComponent("de.laliluna.howto.components.MyHelloComponent")
public class MyHelloComponent extends UIComponentBase{

	private final Logger logger = Logger.getLogger(MyHelloComponent.class.toString());

	public String getFamily() {
		return "de.laliluna.sample";
	}

	@Override
	public void encodeBegin(FacesContext context) throws IOException {
		ResponseWriter writer = context.getResponseWriter();
		writer.startElement("div", null);
		writer.write("hello");
		writer.endElement("div");
	}

	@Override
	public void setRendered(boolean rendered) {
		logger.info("Rendered is set");
		super.setRendered(rendered);
	}

	@Override
	public boolean isRendered() {
		return super.isRendered();
	}

	@Override
	public void setValueExpression(String name, ValueExpression binding) {
		logger.info("Set value ex:"+name);
		super.setValueExpression(name, binding);
	}
}
