package de.laliluna.howto.components;

import de.laliluna.howto.application.CustomFacesContext;

import javax.faces.component.UIInput;
import javax.faces.component.FacesComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.io.IOException;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 26.10.2009
 */
@FacesComponent(value = "de.laliluna.howto.components.WizardId")
public class WizardId extends UIInput {

	

	@Override
	public void encodeBegin(FacesContext context) throws IOException {
		ResponseWriter writer = context.getResponseWriter();
		assert (writer != null);

		writer.startElement("input", this);
		writer.writeAttribute("type", "hidden", "type");
		String clientId = getClientId(context);
		writer.writeAttribute("name", clientId, "clientId");

		// render default text specified
		CustomFacesContext customContext = (CustomFacesContext) context;
		if (customContext.isWizardEnabled()) {
			writer.writeAttribute("value", customContext.getWizardId(), null);
		}
		writer.endElement("input");
	}

	@Override
	public void encodeEnd(FacesContext context) throws IOException {
		
	}

	@Override
	public void decode(FacesContext context) {
		super.decode(context);
		CustomFacesContext customContext = (CustomFacesContext) context;
		Object value = getSubmittedValue();
		if (value != null) {
			customContext.setWizardId(value.toString());
		}
	}
}
