package de.laliluna.howto.services;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

import de.laliluna.howto.beans.Globals;
import de.laliluna.howto.application.CustomFacesContext;

public class GlobalPhaseListener implements PhaseListener {
	final Logger logger = LoggerFactory.getLogger(GlobalPhaseListener.class);

	public void afterPhase(PhaseEvent event) {
		logger.info("global phase listener, after: " + event.getPhaseId());
	}

	public void beforePhase(PhaseEvent event) {
		logger.info("global phase listener, before: " + event.getPhaseId());
		if (event.getPhaseId() == PhaseId.RESTORE_VIEW) {
			// restore a wizard id
			if (event.getFacesContext() instanceof CustomFacesContext) {
				CustomFacesContext context = (CustomFacesContext) event.getFacesContext();
				String key = (String) context.getExternalContext().getSessionMap().remove(Globals.WIZARD_SESSION_KEY);
				if (key != null) {
					context.setWizardId(key);
					logger.debug("Restored wizard id ({})", key);
				}
			}
		}
	}

	public PhaseId getPhaseId() {
		return PhaseId.ANY_PHASE;
	}
}
