package de.laliluna.howto.services;

import org.apache.log4j.Logger;
import org.picocontainer.MutablePicoContainer;
import org.picocontainer.DefaultPicoContainer;

import java.util.Map;
import java.util.HashMap;


public class PicoObjectProvider {
	private static MutablePicoContainer container;
	private static Map<String, Class> nameClassMap;
	private final Logger logger = Logger.getLogger(PicoObjectProvider.class);

	private static PicoObjectProvider INSTANCE = new PicoObjectProvider();

	private PicoObjectProvider() {

	}

	public static PicoObjectProvider getInstance() {
		return INSTANCE;
	}

	public void startUp() {
		logger.debug("Starting Pico container");

		nameClassMap = new HashMap<String, Class>();
		nameClassMap.put("samplePicoService", SamplePicoServiceImpl.class);
		container = new DefaultPicoContainer();
		container.addComponent(SamplePicoServiceImpl.class);
		container.start();
	}

	public Object provide(String beanName) {
		Class objectType = nameClassMap.get(beanName);
		if (objectType == null)
			return null;
		else
			return container.getComponent(objectType);
	}

	public void shutDown() {
		logger.debug("Shutting down Pico container");
		container.stop();
	}
}
