package de.laliluna.examples.pico.extensions;

import de.laliluna.examples.core.SampleServiceImpl;
import net.sourceforge.stripes.action.ActionBean;
import net.sourceforge.stripes.action.ActionBeanContext;
import net.sourceforge.stripes.controller.NameBasedActionResolver;
import org.picocontainer.DefaultPicoContainer;
import org.picocontainer.MutablePicoContainer;

/**
 * Mar 31, 2009
 *
 * @author Sebastian Hennebrueder
 */

public class PicoActionBeanResolver extends NameBasedActionResolver {

	private static final MutablePicoContainer container = new DefaultPicoContainer();

	// Add all business services here
	static {
		// single instance of sampleService		
		container.addComponent(new SampleServiceImpl());
	}

	@Override
	protected void addActionBean(Class<? extends ActionBean> clazz) {
		super.addActionBean(clazz);
		container.addComponent(clazz);
	}

	/**
	 * Helper method to construct and return a new ActionBean instance. Called whenever a new
	 * instance needs to be manufactured.  Provides a convenient point for subclasses to add
	 * specific behaviour during action bean creation.
	 *
	 * @param type		the type of ActionBean to create
	 * @param context the current ActionBeanContext
	 * @return the new ActionBean instance
	 * @throws Exception if anything goes wrong!
	 */
	protected ActionBean makeNewActionBean(Class<? extends ActionBean> type, ActionBeanContext context)
			throws Exception {
		ActionBean result = container.getComponent(type);
		return result;
	}

}
