package de.laliluna.examples.www;

import net.sourceforge.stripes.action.*;
import net.sourceforge.stripes.controller.LifecycleStage;
import de.laliluna.examples.core.DoubleSubmitValidator;

/**
 * Mar 10, 2009
 *
 * @author Sebastian Hennebrueder
 */

public class DoubleSubmit implements ActionBean{
	private ActionBeanContext context;
	

	public ActionBeanContext getContext() {
		return context;
	}

	public void setContext(ActionBeanContext context) {
		this.context = context;
	}

	@DefaultHandler
	public Resolution index(){
		return new ForwardResolution("/doublesubmit.jsp");
	}

	public Resolution save() {
		context.getMessages().add(new SimpleMessage("Submit was fine."));
		return new ForwardResolution("/doublesubmit.jsp");
	}


	@After(stages = LifecycleStage.CustomValidation)
	public Resolution doubleSubmit() {
		String formId = (String) context.getRequest().getParameter("formId");
		if (formId != null) {
			if (DoubleSubmitValidator.submitted(Integer.valueOf(formId))) {
				context.getMessages().add(new SimpleMessage("The form was submitted twice."));
				return new ForwardResolution("/doublesubmit.jsp");
			}
		}

		return null;
	}
}
