package de.laliluna.examples.www;

import net.sourceforge.stripes.action.*;
import net.sourceforge.stripes.controller.LifecycleStage;

import java.util.Arrays;

import de.laliluna.examples.model.Country;
import de.laliluna.examples.core.RequireRole;

/**
 * Mar 10, 2009
 *
 * @author Sebastian Hennebrueder
 */

public class Interceptor implements ActionBean {

	private ActionBeanContext context;


	@DefaultHandler
	public Resolution index() {
		return new ForwardResolution("/interceptor.jsp");
	}

	@RequireRole("secret")
	public Resolution cannotAccess() {
		return new ForwardResolution("/interceptor.jsp");
	}

	@RequireRole("sales")
	public Resolution canAccess() {
		context.getMessages().add(new SimpleMessage("Executed the can access method"));
		return new ForwardResolution("/interceptor.jsp");
	}

	@After(stages = LifecycleStage.ActionBeanResolution)
	public void prepareRequest() {
		context.getRequest()
				.setAttribute("countries", Arrays.asList(new Country("de", "Germany"), new Country("uk", "United Kingdom")));
	}

	public ActionBeanContext getContext() {
		return context;
	}

	public void setContext(ActionBeanContext context) {
		this.context = context;
	}
}
