package de.laliluna.examples.www;

import net.sourceforge.stripes.action.*;
import net.sourceforge.stripes.validation.Validate;
import net.sourceforge.stripes.validation.ValidationMethod;
import net.sourceforge.stripes.validation.ValidationErrors;
import net.sourceforge.stripes.validation.SimpleError;
import net.sourceforge.stripes.controller.LifecycleStage;

import java.util.Date;
import java.util.List;
import java.util.ArrayList;

import de.laliluna.examples.model.Person;

/**
 * Mar 5, 2009
 *
 * @author Sebastian Hennebrueder
 */

public class Validation implements ActionBean {
	private ActionBeanContext context;

	@Validate(on="save", required = true, minlength = 2)
	private String foo;

	private String bar;

	public Validation() {
	}

	public enum Language {EN, DE}

	private Language language;

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Validation");
		sb.append("{foo='").append(foo).append('\'');
		sb.append(", bar='").append(bar).append('\'');
		sb.append(", language=").append(language);
		sb.append('}');
		return sb.toString();
	}

	public Language getLanguage() {
		return language;
	}

	public void setLanguage(Language language) {
		this.language = language;
	}

	public void setFoo(String foo) {
		this.foo = foo;
	}

	public void setBar(String bar) {
		this.bar = bar;
	}

	public String getFoo() {
		return foo;
	}

	public String getBar() {
		return bar;
	}

	@ValidationMethod()
	public void validate() {
		if (foo.equals("bad")) {
			ValidationErrors errors = new ValidationErrors();
			errors.add("foo", new SimpleError("Foos balue is bad"));
			context.setValidationErrors(errors);
		}
		System.out.println(foo);
	}


	public Resolution save() {
		context.getMessages().add(new SimpleMessage("Saved " + new Date()));
		return new RedirectResolution("/validation.jsp");
	}

	public ActionBeanContext getContext() {
		return context;
	}

	public void setContext(ActionBeanContext context) {
		this.context = context;
	}
}
