package de.laliluna.example.mixins;

import org.apache.tapestry5.MarkupWriter;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.annotations.MixinAfter;
import de.laliluna.example.services.FormSubmitIdService;

/**
 * Author: Sebastian Hennebrueder, http://www.laliluna.de
 * Date: 10.08.2009
 */
@MixinAfter
public class DoubleSubmit {

	@Inject
	private FormSubmitIdService serviceSubmit;

	// add hidden field to form with a unique id
	void beginRender(MarkupWriter writer){
		writer.element("input", "type", "hidden", "name", SUBMIT_ID, "value", serviceSubmit.generateId());
		writer.end();
	}

	public static final String SUBMIT_ID = "_submitid";
}
