package de.laliluna.example.model;

import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.beaneditor.Validate;
import org.apache.tapestry5.beaneditor.NonVisual;
import org.apache.tapestry5.beaneditor.ReorderProperties;

import java.util.Date;

/**
 * User: hennebrueder
 * Date: 04.08.2009
 */
@ReorderProperties("salutation,name,city,street")
public class Address extends AbstractModel{
	@NonVisual
	private Integer id;
	/** foo is a custom Validator {@link de.laliluna.example.pages.input.FooValidator}*/
	@Validate("required,minlength=3,foo")
	private String name;
	private String street;
	@Validate("required")
	private String city;
	@Validate("required")
	private String country;
	private Salutation salutation;

	private Date moved;

	private Phone phone;

	public Phone getPhone() {
		return phone;
	}

	public void setPhone(Phone phone) {
		this.phone = phone;
	}

	@Inject
	/**
	 * Inject is a fix to convince Tapestry to use the default constructor instead of the one with the most parameter
	 */
	public Address() {
	}

	public Address(String name, String city, String country, String street, Salutation salutation, Phone phone) {
		this.name = name;
		this.street = street;
		this.city = city;
		this.country = country;
		this.salutation = salutation;
		this.phone = phone;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Salutation getSalutation() {
		return salutation;
	}

	public void setSalutation(Salutation salutation) {
		this.salutation = salutation;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getStreet() {
		return street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public Date getMoved() {
		return moved;
	}

	public void setMoved(Date moved) {
		this.moved = moved;
	}

	public Object clone(){
		Address address = new Address(name, city, country, street, salutation, null);
		address.setId(id);
		address.setMoved(moved != null ? (Date) moved.clone() : null);
		address.setPhone(phone == null ? null : new Phone(phone.getCountryCode(), phone.getAreaPrefix(), phone.getCode()));
		return address;
	}

	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder();
		sb.append("Address");
		sb.append("{name='").append(name).append('\'');
		sb.append(", street='").append(street).append('\'');
		sb.append(", city='").append(city).append('\'');
		sb.append(", country='").append(country).append('\'');
		sb.append(", salutation=").append(salutation);
		sb.append('}');
		return sb.toString();
	}
}
