package de.laliluna.example.pages.wizard;

import de.laliluna.example.model.Address;
import de.laliluna.example.model.Article;
import de.laliluna.example.services.ArticleService;
import org.apache.tapestry5.ioc.annotations.Inject;

/**
 * @author Sebastian Hennebrueder
 */

public class End {

	private Article article;

	@Inject
	private ArticleService storage;

	private Integer articleId;

	/**
	 * Loads the article before the page is rendered
	 * 
	 * @param articleId
	 */
	void onActivate(Integer articleId) {
		this.articleId = articleId;

		article = storage.findById(articleId);
	}

	/**
	 * Encourages Tapestry to add the id to the URL
	 *
	 * @return
	 */
	Integer onPassivate() {
		return articleId;
	}

	public Article getArticle() {
		return article;
	}

	public Object initialize(Integer id) {
		articleId = id;
		return this;
	}
}
