package de.laliluna.example.security;

/**
 * User: hennebrueder
 * Date: 05.08.2009
 */
public interface SecurityService {
	/**
	 * Stores a user in a thread local. Should be called by a request filter, reading the user from the HTTP Session
	 * and storing it here for later use.
	 * Don't forget to call cleanStorage, because Threads are reused in app servers
	 *
	 * @param user - user to be stored
	 */
	void storeUser(ApplicationUser user);

	/**
	 * Replaces the user with an {@link de.laliluna.example.security.LoggedOutUser}. It will later be removed from the
	 * HTTP session by the Request filter {@link de.laliluna.example.security.SecurityRequestFilter}
	 */
	void logoutUser();
	/**
	 * Removes a user from the thread local storage
	 */
	void cleanStorage();

	/**
	 * Gets the user from the thread local storage
	 * @return null if no user was found or the found user
	 */
	ApplicationUser getUser();

}
